<?php
// +----------------------------------------------------------------------+
// | papaan                                                               |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001,2002,2003 Bitflux GmbH                            |
// +----------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or        |
// | modify it under the terms of the GNU General Public License (GPL)    |
// | as published by the Free Software Foundation; either version 2       |
// | of the License, or (at your option) any later version.               |
// | The GPL can be found at http://www.gnu.org/licenses/gpl.html         |
// +----------------------------------------------------------------------+
// | Author: Mike Hommey <mh@glandium.org>                                |
// +----------------------------------------------------------------------+
//
// $Id: serverpages.php,v 1.5 2003/07/24 18:03:51 glandium Exp $

include_once(PAPAAN_BASE."/components/action.php");
include_once(PAPAAN_BASE.'/serverpages/config.php');

/**
* @author   Mike Hommey <mh@glandium.org>
* @version  $Id: serverpages.php,v 1.5 2003/07/24 18:03:51 glandium Exp $
* @package  papaan
*/

class action_serverpages extends action {

	/**
    * Constructor
    *
	*/
	function action_serverpages(&$sitemap, $config) {
		$this->action($sitemap,$config);
	}

	function init($attribs) {
		parent::init($attribs);
	}

	function act() {
		global $logicsheets;
		$CachedFile = $this->sitemap->cacheDir . '/xsp_'.$this->sitemap->generateSitemapID($this->getAttrib('src'));
		/* Buggy ; Need to do that more cleanly */
		if (! (file_exists($CachedFile) && (filemtime($CachedFile) >= filemtime($this->sitemap->base_dir.'/'.$this->getAttrib('src'))))) {
			$xml = $this->readfile($this->getAttrib('src'));
			$this->sitemap->var2XMLObject($xml);
			$xpath = xpath_new_context($xml);
			$xnode = xpath_eval($xpath, '//*[namespace-uri() and namespace-uri()!=\'http://apache.org/xsp\']');
			if (count($xnode->nodeset)) {
				foreach($xnode->nodeset as $node) {
					$ns = $node->namespace_uri();
					if(!isset($seen[$ns])) {
						$seen[$ns] = 1;
						if(isset($logicsheets[$ns])) {
							if (is_file($logicsheets[$ns])) {
								$xslt = domxml_xslt_stylesheet_file($logicsheets[$ns]);
								$xml = $xslt->process($xml);
							} else {
								papaan::raiseError('Logicsheet file not found '.$logicsheets[$ns],PAPAAN_ERROR_FATAL);
							}
						}
					}
				}
			}
			$xslt = domxml_xslt_stylesheet_file($logicsheets['http://apache.org/xsp']);
			$xml = $xslt->process($xml);
			$xslt->result_dump_file($xml, $CachedFile);
		}
		$this->map = array();
		$this->success = false;
		include($CachedFile);

		if ($this->success) {
			return $this->map;
		} else {
			return false;
		}
	}
}
